<%@ page import="org.ultramonkey.l7.model.*,
                 org.ultramonkey.l7.controller.*,
                 org.ultramonkey.l7.view.*" 
    language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>


<%
    /*
     * check session
     */
    L7guiServletBase base = new L7guiServletBase();
    if (session.isNew() || base.checkSession(session) == false) {
        MessageView error = new MessageView(41366, LogCategorySet.GUI_USER_AUTHENTICATION, Message.INVALID_SESSSION); 
        session.setAttribute(SessionKeys.RESULT_MESSAGE, error);
        response.sendRedirect(RedirectPages.LOGIN);
        return;
    }

    /*
     * get sessionTrans
     */
    SessionTransData sessionTrans = (SessionTransData) session.getAttribute(SessionKeys.PAGE_TRANSDATA);
    if (sessionTrans == null){
      MessageView error = new MessageView(41367, LogCategorySet.GUI_SAVE_SYNC, Message.UNEXPECTED_ERROR);
      session.setAttribute(SessionKeys.RESULT_MESSAGE, error);
      response.sendRedirect(RedirectPages.LOGIN);
      return;
    }
	
    String successpage = sessionTrans.destURI;
	String failpage = sessionTrans.errorURI;

	/*
	 * get thread status
	 */
	String threadStatus = (String) session.getAttribute(SessionKeys.THREAD_STATUS);
	if (threadStatus == null) {
		MessageView error = new MessageView(41368, LogCategorySet.GUI_SAVE_SYNC, Message.UNEXPECTED_ERROR);
		session.setAttribute(SessionKeys.RESULT_MESSAGE, error);
		response.sendRedirect(RedirectPages.LOGIN);
		return;
	}
    
    if((successpage == null) || (failpage == null)){
        MessageView error = new MessageView(41369, LogCategorySet.GUI_SAVE_SYNC, Message.UNEXPECTED_ERROR);
        session.setAttribute(SessionKeys.RESULT_MESSAGE, error);
        response.sendRedirect(RedirectPages.LOGIN);
        return;
    }
	else {
	    if (threadStatus.equals(SessionKeys.THREAD_SUCCESS)){
    		response.sendRedirect(successpage);
            return;
    	}
    	else if (threadStatus.equals(SessionKeys.THREAD_RUNNING)){
    		// nothing to do
    	}
    	else if (threadStatus.equals(SessionKeys.THREAD_FAIL)){
    	    response.sendRedirect(failpage);
            return;
    	}
    	else {
    	    MessageView error = new MessageView(41370, LogCategorySet.GUI_SAVE_SYNC, Message.UNEXPECTED_ERROR);
    	    session.setAttribute(SessionKeys.RESULT_MESSAGE, error);
    	    response.sendRedirect(RedirectPages.LOGIN);
    	    return;
    	}
    } 
%>


<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
  	<meta http-equiv="Pragma" content="no-cache">
	<meta http-equiv="Cache-Control" content="no-cache">
	<meta http-equiv="Expires" content="0"> 
  	<meta http-equiv="Content-Script-Type" content="text/javascript" />
  	<meta http-equiv="Content-Style-Type" content="text/css" />
	  <noscript> 
	    <meta http-equiv="refresh" content="<%= RedirectPages.NOSCRIPT_TIME %>; url=<%= RedirectPages.LOGIN %>"/>
	  </noscript> 
	  <meta http-equiv="refresh" content="<%= RedirectPages.REFRESH_TIME %>"/>  
	  
	  <link rel="stylesheet" type="text/css" href="l7gui_basic_style.css" />
	  <link rel="shortcut icon" href="images/favicon.ico" />
	  <title>Running : Save and Sync</title>
</head>

<body>

<h1 class="title">Running : Save and Sync</h1>
<h2>Please wait.</h2>

</body>
</html>

