package org.ultramonkey.l7.controller;

import java.io.Serializable;
import java.util.Vector;

import org.apache.log4j.Logger;
import org.ultramonkey.l7.model.LogCategorySet;

public class DirectorData implements Serializable {
	static final long serialVersionUID = 1;

	public String checkTimeOut;

	public String negotiateTimeOut;

	public String checkInterval;

	public String checkCount;

	public boolean autoreload;

	public String callback;

	public String fallback;

	public String logfile;

	public String execute;

	public String supervised;

	public String quiescent;

	public Vector<VirtualSetting> virtualSettings;

	public DirectorData() {
       // --- debug log (constructor) ---
		Logger ioFileLogger = Logger.getLogger(LogCategorySet.GUI_IO_FILE);
        if (ioFileLogger.isDebugEnabled()) {
            ioFileLogger.debug("11582 class DirectorData created.");
        }
       // --- debug log (constructor) ---
		this.autoreload = false;
		this.callback = "";
		this.checkCount = "";
		this.checkInterval = "";
		this.checkTimeOut = "";
		this.execute = "";
		this.fallback = "";
		this.logfile = "";
		this.negotiateTimeOut = "";
		this.quiescent = "";
		this.supervised = "";
		this.virtualSettings = new Vector<VirtualSetting>();
	}

	public DirectorData( DirectorData inData ){
	       // --- debug log (constructor) ---
		Logger ioFileLogger = Logger.getLogger(LogCategorySet.GUI_IO_FILE);
        if (ioFileLogger.isDebugEnabled()) {
            ioFileLogger.debug("11583 class DirectorData created.");
        }
       // --- debug log (constructor) ---
		this.autoreload = inData.autoreload;
		this.callback = inData.callback;
		this.checkCount = inData.checkCount;
		this.checkInterval = inData.checkInterval;
		this.checkTimeOut = inData.checkTimeOut;
		this.execute = inData.execute;
		this.fallback = inData.fallback;
		this.logfile = inData.logfile;
		this.negotiateTimeOut = inData.negotiateTimeOut;
		this.quiescent = inData.quiescent;
		this.supervised = inData.supervised;
		this.virtualSettings = inData.virtualSettings;
	}
	
	public boolean equals(DirectorData in) {
		if(	this.autoreload == in.autoreload &&
				this.callback.equals(in.callback) &&
				this.checkCount.equals(in.checkCount) &&
				this.checkInterval.equals(in.checkInterval) &&
				this.checkTimeOut.equals(in.checkTimeOut) &&
				this.fallback.equals(in.fallback) &&
				this.logfile.equals(in.logfile) &&
				this.negotiateTimeOut.equals(in.negotiateTimeOut) &&
				this.supervised.equals(in.supervised) &&
				this.virtualSettings.equals(in.virtualSettings)){
				return true;
		}
		return false;
	}

	public String toString() {
		return 
			"checkTimeOut=\"" + this.checkTimeOut + "\", " +
			"negotiateTimeOut=\"" + this.negotiateTimeOut + "\", " +
			"checkInterval=\"" + this.checkInterval + "\", " +
			"checkCount=\"" + this.checkCount + "\", " +
			"autoreload=" + this.autoreload + ", " +
			"callback=\"" + this.callback + "\", " +
			"fallback=\"" + this.fallback + "\", " +
			"logfile=\"" + this.logfile + "\", " +
			"execute=\"" + this.execute + "\", " +
			"supervised=\"" + this.supervised + "\", " +
			"quiescent=\"" + this.quiescent + "\", " +
			"virtualSettings=(" + this.virtualSettings + ")";
	}
}
