package org.ultramonkey.l7.model;

/**
 * <p>class Message</p>
 * <p>Copyright(c) NTT COMWARE 2008</p>
 * @author tsubone
 */
public interface Message {
    public static final String INVALID_SESSSION = "Invalid session.";

    public static final String UNEXPECTED_ERROR = "Unexpected error.";

    public static final String USERID_PASSWORD_ERROR = "Invalid \"User ID\" or \"Password\".";

    public static final String USER_AUTH_ERROR = "User Authentication failed.";

    public static final String VALIDATION_ERROR = "Validation error.";

    public static final String INVALID_VALUE = "Invalid value.";

    public static final String REQUIED_ITEM = "Required fields.";

    public static final String NOT_INPUT_ITEM = "Please fill in the required fields.";

    public static final String DIRECTOR_DATA_ERROR = "Cannot get the l7directord.cf data.";
    
    public static final String DIRECTOR_SYNTAX_ERROR = "Syntax error of l7directord.cf";

    public static final String L7VS_CONF_DATA_ERROR = "Cannot get the l7vs.cf data.";

    public static final String CLUSTER_DATA_ERROR = "Cannot get the cluster data.";

    public static final String VS_SELECT_ERROR = "Please select one of the following VirtualServices.";

    public static final String NOT_EQUAL = "The Password and confirmation Password do not match.";

    public static final String PASSWORD_INVALID = "Invalid current Password.";

    public static final String SAVE_CATEGORY_SELECT_ERROR = "Please select one or some of the followings.";

    public static final String SAVE_LOG_VS_SUCCESS = "Log's and VirtualService's settings have been saved.";

    public static final String SAVE_LOG_SUCCESS = "Log's setting has been saved.";

    public static final String SAVE_VS_SUCCESS = "VirtualService's setting has been saved. ";

    public static final String SAVE_LOG_FAIL = "Failed to save Log's setting.";

    public static final String SAVE_VS_FAIL = "Failed to save VirtualService's setting.";

    public static final String SAVE_LOG_VS_FAIL = "Failed to save Log's and VirtualService's settings";

    public static final String NO_VS = "Such VirtualService does not exist.";

    public static final String ADD_VS_ERROR = "Failed to add VirtualService.";

    public static final String SYNC_CATEGORY_SELECT_ERROR = "Please select one or some of the followings.";

    public static final String NOT_EXIST = "All fields are empty.";

    public static final String WRITE_ERROR = "Cannot write file.";

    public static final String WRITE_ERROR_L7DIRECTORD = "Cannot write new data to the l7directord.cf file.";

    public static final String WRITE_ERROR_L7VS = "Cannot write new data to the l7vs.cf file.";

    public static final String READ_ERROR = "Cannot read file.";

    public static final String USER_CHANGE_SUCCESS = "User data changed.";

    public static final String USER_ADD_SUCCESS = "New user added.";

    public static final String USER_MAX = "GUI Users is up to 16 users. You cannot add over 16 users.";
    
    public static final String SAME_USER_EXISTS = "Already the same user exists.";

    public static final String USER_REMOVE_SELECT_ERROR = "Please select one or some of the followings.";

    public static final String SELF_USER_DELETE = "Cannot delete yourself.";

    public static final String USER_DELETE_SUCCESS = "User deleted.";

    public static final String USER_DELETE_FAIL = "Failed to delete user.";

    public static final String LOG_NOT_FOUND = "Log file is not found.";

    public static final String REAL_SERVER_EXIST = "Already the same RealServer exists.";

    public static final String VIRTUAL_SERVER_EXIST = "Already the same VirtualService exists.";

    public static final String SYNC_ERROR_L7DIRECTORD = "Failed in the synchronization of the l7directord.cf file.";

    public static final String SYNC_ERROR_L7VS = "Failed in the synchronization of the l7vs.cf file.";

    public static final String L7VSADM_ERROR = "An error occurred while processing l7vsadm command.";

    public static final String CLUSTER_COMMAND_ERROR = "An error occurred while processing cluster management command.";

    public static final String DIRECTOR_SAVE = "Succeeded to modify monitor settings.";
    
    public static final String DIRECTOR_SAVESYNC = "Succeeded to modify and sync monitor settings.";
    
    public static final String VS_ADD_APPLY = "Succeeded to add a new VirtualService setting.";
    
    public static final String VS_ADD_SAVE = "Succeeded to add and save a new VirtualService setting. If the settings is not reflected in the following list, please refresh this page after waited for a while.";
    
    public static final String VS_ADD_SAVESYNC = "Succeeded to add, save, and sync a new VirtualService setting. If the settings is not reflected in the following list, please refresh this page after waited for a while.";
    
    public static final String VS_REMOVE_APPLY = "Succeeded to remove a VirtualService setting.";
    
    public static final String VS_REMOVE_SAVE = "Succeeded to remove and save a VirtualService setting. If the settings is not reflected in the following list, please refresh this page after waited for a while.";
    
    public static final String VS_REMOVE_SAVESYNC = "Succeeded to remove and save, sync a VirtualService setting. If the settings is not reflected in the following list, please refresh this page after waited for a while.";
    
    public static final String VS_MODIFY_APPLY = "Succeeded to modify VirtualService setting.";
    
    public static final String VS_MODIFY_SAVE = "Succeeded to modify and save VirtualService setting. If the settings is not reflected in the following list, please refresh this page after waited for a while.";
    
    public static final String VS_MODIFY_SAVESYNC = "Succeeded to modify, save and sync VirtualService setting. If the settings is not reflected in the following list, please refresh this page after waited for a while.";
    
    public static final String CLUSTER_SWITCHORVER = "Succeeded to switch-over cluster.";
    
    public static final String REP_MASTER = "Succeeded to start replication.";
    
    public static final String REP_MASTER_STOP = "Succeeded to stop replication.";
    
    public static final String REP_SLAVE = "Succeeded to start replication.";
    
    public static final String REP_SLAVE_STOP = "Succeeded to stop replication.";
    
    public static final String REP_INFO_SAVE = "Succeeded to modify and save replication setting.";
    
    public static final String REP_INFO_SAVESYNC = "Succeeded to modify, save and sync replication setting.";
    
    public static final String REP_START = "Succeeded to dump replication data.";
    
    public static final String LOGLEVEL_CHANGE_APPLY = "Succeeded to change log level.";
    
    public static final String LOGLEVEL_CHANGE_SAVE = "Succeeded to change and save log level.";
    
    public static final String LOGLEVEL_CHANGE_SAVESYNC = "Succeeded to change, save and sync log level";
    
    public static final String SNMP_INFO_SAVE = "Succeeded to change and save SNMP Agent setting.";
    
    public static final String SNMP_INFO_SAVESYNC = "Succeeded to change, save and sync SNMP Agent setting.";
    
    public static final String SYNC = "Succeeded to sync resources.";
       
    //  Messages for L7GUI synchronous processing
    public static final String SYNC_INVALID_CATEGORY_ID = "Invalid category id.";

    public static final String SYNC_ENCODE_ERROR = "Failed to serialize or encode.";

    public static final String SYNC_DECODE_ERROR = "Failed to decode or deserialize.";

    public static final String SYNC_SET_ERROR = "Failed to set ";

    public static final String SYNC_GET_ERROR = "Failed to get data";

    public static final String SYNC_OPEN_ERROR = "Failed to open connection";

    public static final String SYNC_FAIL = "Failed to synchronize ";

    public static final String SYNC_SEND_ERROR = "Failed to send data";

    public static final String SYNC_INVALID_ARGUMENT = "Invalid argument supplied for";

    public static final String SYNC_RECV_ERROR = "Failed to receive data";

    public static final String SYNC_CLOSE_ERROR = "Failed to close connection.";

    public static final String SYNC_INVALID_RECV_DATA = "Invalid receive data.";

    public static final String SYNC_SUCCESS = " was synchronized.";

    public static final String SYNC_DIFFERENT_DATA = "Different data between active server and stand-by server";

    public static final String SYNC_SAME_DATA = "The same data between active server and stand-by server";

    public static final String SYNC_INVALID_SERVER_MODE = "Invalid server mode.";
}
